{
    rho = gamma*rho1 + (scalar(1) - gamma)*rho2;

    // Add gravity term, re-using the momentum equation
    UEqn += interface.sigmaK()*fvc::grad(gamma) - rho*g;

    volScalarField rUAPres = 1.0/UEqn.A();

    // Pick up velocity boundary conditions
    volVectorField Upres = U;
    Upres = rUAPres*UEqn.H();

    surfaceScalarField phiPres = fvc::interpolate(Upres) & mesh.Sf();

    p.storePrevIter();

    for(int nonOrth = 0; nonOrth <= nNonOrthCorr; nonOrth++)
    {
        fvScalarMatrix pEqn
        (
            fvm::laplacian(rUAPres, p) == fvc::div(phiPres)
        );

        pEqn.setReference(pRefCell, pRefValue);
        pEqn.solve();
    }

    Info << "Relaxation: p = " << mesh.relaxationFactor(p.name()) << endl;
    p.relax();
}
